/*!
 * AngularJS Material Design
 * https://github.com/angular/material
 * @license MIT
 * v1.1.22-master-000a023
 */
goog.provide("ngmaterial.components.panel"),goog.require("ngmaterial.components.backdrop"),goog.require("ngmaterial.core"),MdPanelService.$inject=["presets","$rootElement","$rootScope","$injector","$window"],angular.module("material.components.panel",["material.core","material.components.backdrop"]).provider("$mdPanel",MdPanelProvider);var MD_PANEL_Z_INDEX=80,MD_PANEL_HIDDEN="_md-panel-hidden",FOCUS_TRAP_TEMPLATE=angular.element('<div class="_md-panel-focus-trap" tabindex="0"></div>'),_presets={};function MdPanelProvider(){return{definePreset:definePreset,getAllPresets:getAllPresets,clearPresets:clearPresets,$get:$getProvider()}}function definePreset(e,t){if(!e||!t)throw new Error("mdPanelProvider: The panel preset definition is malformed. The name and preset object are required.");if(_presets.hasOwnProperty(e))throw new Error("mdPanelProvider: The panel preset you have requested has already been defined.");delete t.id,delete t.position,delete t.animation,_presets[e]=t}function getAllPresets(){return angular.copy(_presets)}function clearPresets(){_presets={}}function $getProvider(){return["$rootElement","$rootScope","$injector","$window",function(e,t,n,i){return new MdPanelService(_presets,e,t,n,i)}]}function MdPanelService(e,t,n,i,o){this._defaultConfigOptions={bindToController:!0,clickOutsideToClose:!1,disableParentScroll:!1,escapeToClose:!1,focusOnOpen:!0,fullscreen:!1,hasBackdrop:!1,propagateContainerEvents:!1,transformTemplate:angular.bind(this,this._wrapTemplate),trapFocus:!1,zIndex:MD_PANEL_Z_INDEX},this._config={},this._presets=e,this._$rootElement=t,this._$rootScope=n,this._$injector=i,this._$window=o,this._$mdUtil=this._$injector.get("$mdUtil"),this._trackedPanels={},this._groups=Object.create(null),this.animation=MdPanelAnimation.animation,this.xPosition=MdPanelPosition.xPosition,this.yPosition=MdPanelPosition.yPosition,this.interceptorTypes=MdPanelRef.interceptorTypes,this.closeReasons=MdPanelRef.closeReasons,this.absPosition=MdPanelPosition.absPosition}function MdPanelRef(e,t){this._$q=t.get("$q"),this._$mdCompiler=t.get("$mdCompiler"),this._$mdConstant=t.get("$mdConstant"),this._$mdUtil=t.get("$mdUtil"),this._$mdTheming=t.get("$mdTheming"),this._$rootScope=t.get("$rootScope"),this._$animate=t.get("$animate"),this._$mdPanel=t.get("$mdPanel"),this._$log=t.get("$log"),this._$window=t.get("$window"),this._$$rAF=t.get("$$rAF"),this.id=e.id,this.config=e,this.panelContainer=void 0,this.panelEl=void 0,this.innerWrapper=void 0,this.isAttached=!1,this._removeListeners=[],this._topFocusTrap=void 0,this._bottomFocusTrap=void 0,this._backdropRef=void 0,this._restoreScroll=null,this._interceptors=Object.create(null),this._compilerCleanup=null,this._restoreCache={styles:"",classes:""}}function MdPanelPosition(e){this._$window=e.get("$window"),this._isRTL=e.get("$mdUtil").isRtl(),this._$mdConstant=e.get("$mdConstant"),this._absolute=!1,this._relativeToEl=void 0,this._top="",this._bottom="",this._left="",this._right="",this._translateX=[],this._translateY=[],this._positions=[],this._actualPosition=void 0}function MdPanelAnimation(e){this._$mdUtil=e.get("$mdUtil"),this._openFrom,this._closeTo,this._animationClass="",this._openDuration,this._closeDuration,this._rawDuration}function getElement(e){var t=angular.isString(e)?document.querySelector(e):e;return angular.element(t)}function getComputedTranslations(e,t){var n=getComputedStyle(e[0]||e)[t],i=n.indexOf("("),o=n.lastIndexOf(")"),a={x:0,y:0};if(-1<i&&-1<o){var s=n.substring(i+1,o).split(", ").slice(-2);a.x=parseInt(s[0]),a.y=parseInt(s[1])}return a}function validatePosition(e,t){if(null!==t&&!angular.isUndefined(t)){for(var n,i=Object.keys(e),o=[],a=0;n=i[a];a++){var s=e[n];if(o.push(s),s===t)return}throw new Error("Panel position only accepts the following values:\n"+o.join(" | "))}}function addUnits(e){return angular.isNumber(e)?e+"px":e}MdPanelService.prototype.create=function(e,t){if("string"==typeof e?e=this._getPresetByName(e):"object"!=typeof e||!angular.isUndefined(t)&&t||(t=e,e={}),e=e||{},t=t||{},angular.isDefined(t.id)&&this._trackedPanels[t.id]){var n=this._trackedPanels[t.id];return angular.extend(n.config,t),n}this._config=angular.extend({id:t.id||"panel_"+this._$mdUtil.nextUid(),scope:this._$rootScope.$new(!0),attachTo:this._$rootElement},this._defaultConfigOptions,t,e);var i=new MdPanelRef(this._config,this._$injector);return this._trackedPanels[this._config.id]=i,this._config.groupName&&(angular.isString(this._config.groupName)&&(this._config.groupName=[this._config.groupName]),angular.forEach(this._config.groupName,function(e){i.addToGroup(e)})),this._config.scope.$on("$destroy",angular.bind(i,i.detach)),i},MdPanelService.prototype.open=function(e,t){var n=this.create(e,t);return n.open().then(function(){return n})},MdPanelService.prototype._getPresetByName=function(e){if(!this._presets[e])throw new Error("mdPanel: The panel preset configuration that you requested does not exist. Use the $mdPanelProvider to create a preset before requesting one.");return this._presets[e]},MdPanelService.prototype.newPanelPosition=function(){return new MdPanelPosition(this._$injector)},MdPanelService.prototype.newPanelAnimation=function(){return new MdPanelAnimation(this._$injector)},MdPanelService.prototype.newPanelGroup=function(e,t){if(!this._groups[e]){var n={panels:[],openPanels:[],maxOpen:0<(t=t||{}).maxOpen?t.maxOpen:1/0};this._groups[e]=n}return this._groups[e]},MdPanelService.prototype.setGroupMaxOpen=function(e,t){if(!this._groups[e])throw new Error("mdPanel: Group does not exist yet. Call newPanelGroup().");this._groups[e].maxOpen=t},MdPanelService.prototype._openCountExceedsMaxOpen=function(e){if(this._groups[e]){var t=this._groups[e];return 0<t.maxOpen&&t.openPanels.length>t.maxOpen}return!1},MdPanelService.prototype._closeFirstOpenedPanel=function(e){this._groups[e].openPanels[0].close()},MdPanelService.prototype._wrapTemplate=function(e){return'<div class="md-panel-outer-wrapper"><div class="md-panel-inner-wrapper _md-panel-offscreen"><div class="md-panel _md-panel-offscreen">'+(e||"")+"</div></div></div>"},MdPanelService.prototype._wrapContentElement=function(e){var t=angular.element('<div class="md-panel-outer-wrapper"><div class="md-panel-inner-wrapper _md-panel-offscreen"></div></div>');return e.addClass("md-panel _md-panel-offscreen"),t.children().eq(0).append(e),t},MdPanelRef.interceptorTypes={CLOSE:"onClose"},MdPanelRef.prototype.open=function(){var o=this;return this._$q(function(e,t){var n=o._done(e,o),i=o._simpleBind(o.show,o);o.attach().then(i).then(function(){o.config.groupName&&angular.forEach(o.config.groupName,function(e){o._$mdPanel._openCountExceedsMaxOpen(e)&&o._$mdPanel._closeFirstOpenedPanel(e)})}).then(n).catch(t)})},MdPanelRef.prototype.close=function(a){var s=this;return this._$q(function(i,o){s._callInterceptors(MdPanelRef.interceptorTypes.CLOSE).then(function(){var e=s._done(i,s),t=s._simpleBind(s.detach,s),n=s.config.onCloseSuccess||angular.noop;n=angular.bind(s,n,s,a),s.hide().then(t).then(e).then(n).catch(o)},o)})},MdPanelRef.prototype.attach=function(){if(this.isAttached&&this.panelEl)return this._$q.when(this);var o=this;return this._$q(function(e,t){var n=o._done(e,o),i=o.config.onDomAdded||angular.noop;o._$q.all([o._createBackdrop(),o._createPanel().then(function(e){return o.isAttached=!0,o._addEventListeners(),e}).catch(t)]).then(i).then(n).catch(t)})},MdPanelRef.prototype.detach=function(){if(!this.isAttached)return this._$q.when(this);var i=this,o=i.config.onDomRemoved||angular.noop;return this._restoreScroll&&(this._restoreScroll(),this._restoreScroll=null),this._$q(function(e,t){var n=i._done(e,i);i._$q.all([(i._removeEventListeners(),i._topFocusTrap&&i._topFocusTrap.parentNode&&i._topFocusTrap.parentNode.removeChild(i._topFocusTrap),i._bottomFocusTrap&&i._bottomFocusTrap.parentNode&&i._bottomFocusTrap.parentNode.removeChild(i._bottomFocusTrap),i._restoreCache.classes&&(i.panelEl[0].className=i._restoreCache.classes),i.panelEl[0].style.cssText=i._restoreCache.styles||"",i._compilerCleanup(),i.panelContainer.remove(),i.isAttached=!1,i._$q.when(i)),!i._backdropRef||i._backdropRef.detach()]).then(o).then(n).catch(t)})},MdPanelRef.prototype.destroy=function(){var t=this;this.config.groupName&&angular.forEach(this.config.groupName,function(e){t.removeFromGroup(e)}),this.config.scope.$destroy(),this.config.locals=null,this.config.onDomAdded=null,this.config.onDomRemoved=null,this.config.onRemoving=null,this.config.onOpenComplete=null,this._interceptors=null},MdPanelRef.prototype.show=function(){if(!this.panelContainer)return this._$q(function(e,t){t("mdPanel: Panel does not exist yet. Call open() or attach().")});if(!this.panelContainer.hasClass(MD_PANEL_HIDDEN))return this._$q.when(this);var o=this;return this._$q(function(e,t){var n=o._done(e,o),i=o.config.onOpenComplete||angular.noop;o._$q.all([o._backdropRef?o._backdropRef.show():o,(o.panelContainer.removeClass(MD_PANEL_HIDDEN),o._animateOpen()).then(function(){o._focusOnOpen()},t)]).then(i).then(function(){o.config.groupName&&angular.forEach(o.config.groupName,function(e){o._$mdPanel._groups[e].openPanels.push(o)})}).then(n).catch(t)})},MdPanelRef.prototype.hide=function(){if(!this.panelContainer)return this._$q(function(e,t){t("mdPanel: Panel does not exist yet. Call open() or attach().")});if(this.panelContainer.hasClass(MD_PANEL_HIDDEN))return this._$q.when(this);var o=this;return this._$q(function(e,t){var n=o._done(e,o),i=o.config.onRemoving||angular.noop;o._$q.all([o._backdropRef?o._backdropRef.hide():o,o._animateClose().then(i).then(function(){o.panelContainer.addClass(MD_PANEL_HIDDEN)}).then(function(){var t;o.config.groupName&&angular.forEach(o.config.groupName,function(e){e=o._$mdPanel._groups[e],-1<(t=e.openPanels.indexOf(o))&&e.openPanels.splice(t,1)})}).then(function(){var e=o.config.origin;e&&getElement(e).focus()}).catch(t)]).then(n,t)})},MdPanelRef.prototype.addClass=function(e,t){if(this._$log.warn("mdPanel: The addClass method is in the process of being deprecated. Full deprecation is scheduled for the AngularJS Material 1.2 release. To achieve the same results, use the panelContainer or panelEl JQLite elements that are referenced in MdPanelRef."),!this.panelContainer)throw new Error("mdPanel: Panel does not exist yet. Call open() or attach().");t||this.panelContainer.hasClass(e)?t&&!this.panelEl.hasClass(e)&&this.panelEl.addClass(e):this.panelContainer.addClass(e)},MdPanelRef.prototype.removeClass=function(e,t){if(this._$log.warn("mdPanel: The removeClass method is in the process of being deprecated. Full deprecation is scheduled for the AngularJS Material 1.2 release. To achieve the same results, use the panelContainer or panelEl JQLite elements that are referenced in MdPanelRef."),!this.panelContainer)throw new Error("mdPanel: Panel does not exist yet. Call open() or attach().");!t&&this.panelContainer.hasClass(e)?this.panelContainer.removeClass(e):t&&this.panelEl.hasClass(e)&&this.panelEl.removeClass(e)},MdPanelRef.prototype.toggleClass=function(e,t){if(this._$log.warn("mdPanel: The toggleClass method is in the process of being deprecated. Full deprecation is scheduled for the AngularJS Material 1.2 release. To achieve the same results, use the panelContainer or panelEl JQLite elements that are referenced in MdPanelRef."),!this.panelContainer)throw new Error("mdPanel: Panel does not exist yet. Call open() or attach().");t?this.panelEl.toggleClass(e):this.panelContainer.toggleClass(e)},MdPanelRef.prototype._compile=function(){var i=this;return i._$mdCompiler.compile(i.config).then(function(e){var t=i.config;if(t.contentElement){var n=e.element;i._restoreCache.styles=n[0].style.cssText,i._restoreCache.classes=n[0].className,i.panelContainer=i._$mdPanel._wrapContentElement(n),i.panelEl=n}else i.panelContainer=e.link(t.scope),i.panelEl=angular.element(i.panelContainer[0].querySelector(".md-panel"));return i.innerWrapper=angular.element(i.panelContainer[0].querySelector(".md-panel-inner-wrapper")),i._compilerCleanup=e.cleanup,getElement(i.config.attachTo).append(i.panelContainer),i})},MdPanelRef.prototype._createPanel=function(){var n=this;return this._$q(function(e,t){n.config.locals||(n.config.locals={}),(n.config.locals.mdPanelRef=n)._compile().then(function(){n.config.disableParentScroll&&(n._restoreScroll=n._$mdUtil.disableScrollAround(null,n.panelContainer,{disableScrollMask:!0})),n.config.panelClass&&n.panelEl.addClass(n.config.panelClass),n.config.propagateContainerEvents&&(n.panelContainer.css("pointer-events","none"),n.panelEl.css("pointer-events","all")),n._$animate.pin&&n._$animate.pin(n.panelContainer,getElement(n.config.attachTo)),n._configureTrapFocus(),n._addStyles().then(function(){e(n)},t)},t)})},MdPanelRef.prototype._addStyles=function(){var n=this;return this._$q(function(e){n.panelContainer.css("z-index",n.config.zIndex),n.innerWrapper.css("z-index",n.config.zIndex+1);function t(){n._setTheming(),n.panelEl.removeClass("_md-panel-offscreen"),n.innerWrapper.removeClass("_md-panel-offscreen"),n.panelContainer.addClass(MD_PANEL_HIDDEN),e(n)}if(n.config.fullscreen)return n.panelEl.addClass("_md-panel-fullscreen"),void t();n.config.position?n._$rootScope.$$postDigest(function(){n._updatePosition(!0),n._setTheming(),e(n)}):t()})},MdPanelRef.prototype._setTheming=function(){this._$mdTheming(this.panelEl),this._$mdTheming(this.panelContainer)},MdPanelRef.prototype.updatePosition=function(e){if(!this.panelContainer)throw new Error("mdPanel: Panel does not exist yet. Call open() or attach().");this.config.position=e,this._updatePosition()},MdPanelRef.prototype._updatePosition=function(e){var t=this.config.position;t&&(t._setPanelPosition(this.innerWrapper),e&&(this.panelEl.removeClass("_md-panel-offscreen"),this.panelContainer.addClass(MD_PANEL_HIDDEN)),this.innerWrapper.css(MdPanelPosition.absPosition.TOP,t.getTop()),this.innerWrapper.css(MdPanelPosition.absPosition.BOTTOM,t.getBottom()),this.innerWrapper.css(MdPanelPosition.absPosition.LEFT,t.getLeft()),this.innerWrapper.css(MdPanelPosition.absPosition.RIGHT,t.getRight()))},MdPanelRef.prototype._focusOnOpen=function(){if(this.config.focusOnOpen){var e=this;this._$rootScope.$$postDigest(function(){(e._$mdUtil.findFocusTarget(e.panelEl)||e.panelEl).focus()})}},MdPanelRef.prototype._createBackdrop=function(){if(this.config.hasBackdrop){if(!this._backdropRef){var e=this._$mdPanel.newPanelAnimation().openFrom(this.config.attachTo).withAnimation({open:"_md-opaque-enter",close:"_md-opaque-leave"});this.config.animation&&e.duration(this.config.animation._rawDuration);var t={animation:e,attachTo:this.config.attachTo,focusOnOpen:!1,panelClass:"_md-panel-backdrop",zIndex:this.config.zIndex-1};this._backdropRef=this._$mdPanel.create(t)}if(!this._backdropRef.isAttached)return this._backdropRef.attach()}},MdPanelRef.prototype._addEventListeners=function(){this._configureEscapeToClose(),this._configureClickOutsideToClose(),this._configureScrollListener()},MdPanelRef.prototype._removeEventListeners=function(){this._removeListeners&&this._removeListeners.forEach(function(e){e()}),this._removeListeners=[]},MdPanelRef.prototype._configureEscapeToClose=function(){if(this.config.escapeToClose){function e(e){e.keyCode===n._$mdConstant.KEY_CODE.ESCAPE&&(e.stopPropagation(),e.preventDefault(),n.close(MdPanelRef.closeReasons.ESCAPE))}var t=getElement(this.config.attachTo),n=this;this.panelContainer.on("keydown",e),t.on("keydown",e),this._removeListeners.push(function(){n.panelContainer.off("keydown",e),t.off("keydown",e)})}},MdPanelRef.prototype._configureClickOutsideToClose=function(){if(this.config.clickOutsideToClose){function e(e){n=e.target}function t(e){o.config.propagateContainerEvents?n===o.panelEl[0]||o.panelEl[0].contains(n)||o.close():n===i[0]&&e.target===i[0]&&(e.stopPropagation(),e.preventDefault(),o.close(MdPanelRef.closeReasons.CLICK_OUTSIDE))}var n,i=this.config.propagateContainerEvents?angular.element(document.body):this.panelContainer,o=this;i.on("mousedown",e),i.on("mouseup",t),this._removeListeners.push(function(){i.off("mousedown",e),i.off("mouseup",t)})}},MdPanelRef.prototype._configureScrollListener=function(){if(!this.config.disableParentScroll){function e(){n()}var t=angular.bind(this,this._updatePosition),n=this._$$rAF.throttle(t),i=this;this._$window.addEventListener("scroll",e,!0),this._removeListeners.push(function(){i._$window.removeEventListener("scroll",e,!0)})}},MdPanelRef.prototype._configureTrapFocus=function(){if(this.panelEl.attr("tabIndex","-1"),this.config.trapFocus){var e=this.panelEl;this._topFocusTrap=FOCUS_TRAP_TEMPLATE.clone()[0],this._bottomFocusTrap=FOCUS_TRAP_TEMPLATE.clone()[0];function t(){e.focus()}this._topFocusTrap.addEventListener("focus",t),this._bottomFocusTrap.addEventListener("focus",t),this._removeListeners.push(this._simpleBind(function(){this._topFocusTrap.removeEventListener("focus",t),this._bottomFocusTrap.removeEventListener("focus",t)},this)),e[0].parentNode.insertBefore(this._topFocusTrap,e[0]),e.after(this._bottomFocusTrap)}},MdPanelRef.prototype.updateAnimation=function(e){this.config.animation=e,this._backdropRef&&this._backdropRef.config.animation.duration(e._rawDuration)},MdPanelRef.prototype._animateOpen=function(){this.panelContainer.addClass("md-panel-is-showing");var n=this.config.animation;if(!n)return this.panelContainer.addClass("_md-panel-shown"),this._$q.when(this);var i=this;return this._$q(function(e){var t=i._done(e,i);n.animateOpen(i.panelEl).then(t,function(){i._$log.warn("mdPanel: MdPanel Animations failed. Showing panel without animating."),t()})})},MdPanelRef.prototype._animateClose=function(){var n=this.config.animation;if(!n)return this.panelContainer.removeClass("md-panel-is-showing"),this.panelContainer.removeClass("_md-panel-shown"),this._$q.when(this);var i=this;return this._$q(function(e){function t(){i.panelContainer.removeClass("md-panel-is-showing"),e(i)}n.animateClose(i.panelEl).then(t,function(){i._$log.warn("mdPanel: MdPanel Animations failed. Hiding panel without animating."),t()})})},MdPanelRef.prototype.registerInterceptor=function(e,t){var n=null;if(angular.isString(e)?angular.isFunction(t)||(n="Interceptor callback must be a function, instead got "+typeof t):n="Interceptor type must be a string, instead got "+typeof e,n)throw new Error("MdPanel: "+n);var i=this._interceptors[e]=this._interceptors[e]||[];return-1===i.indexOf(t)&&i.push(t),this},MdPanelRef.prototype.removeInterceptor=function(e,t){var n=this._interceptors[e]?this._interceptors[e].indexOf(t):-1;return-1<n&&this._interceptors[e].splice(n,1),this},MdPanelRef.prototype.removeAllInterceptors=function(e){return e?this._interceptors[e]=[]:this._interceptors=Object.create(null),this},MdPanelRef.prototype._callInterceptors=function(e){var i=this,o=i._$q;return(i._interceptors&&i._interceptors[e]||[]).reduceRight(function(e,t){var n=t&&angular.isFunction(t.then)?t:null;return e.then(function(){if(!n)try{n=t(i)}catch(e){n=o.reject(e)}return n})},o.resolve(i))},MdPanelRef.prototype._simpleBind=function(t,n){return function(e){return t.apply(n,e)}},MdPanelRef.prototype._done=function(e,t){return function(){e(t)}},MdPanelRef.prototype.addToGroup=function(e){this._$mdPanel._groups[e]||this._$mdPanel.newPanelGroup(e);var t=this._$mdPanel._groups[e];t.panels.indexOf(this)<0&&t.panels.push(this)},MdPanelRef.prototype.removeFromGroup=function(e){if(!this._$mdPanel._groups[e])throw new Error("mdPanel: The group "+e+" does not exist.");var t=this._$mdPanel._groups[e],n=t.panels.indexOf(this);-1<n&&t.panels.splice(n,1)},MdPanelRef.closeReasons={CLICK_OUTSIDE:"clickOutsideToClose",ESCAPE:"escapeToClose"},MdPanelPosition.xPosition={CENTER:"center",ALIGN_START:"align-start",ALIGN_END:"align-end",OFFSET_START:"offset-start",OFFSET_END:"offset-end"},MdPanelPosition.yPosition={CENTER:"center",ALIGN_TOPS:"align-tops",ALIGN_BOTTOMS:"align-bottoms",ABOVE:"above",BELOW:"below"},MdPanelPosition.absPosition={TOP:"top",RIGHT:"right",BOTTOM:"bottom",LEFT:"left"},MdPanelPosition.viewportMargin=8,MdPanelPosition.prototype.absolute=function(){return this._absolute=!0,this},MdPanelPosition.prototype._setPosition=function(e,t){if(e===MdPanelPosition.absPosition.RIGHT||e===MdPanelPosition.absPosition.LEFT)this._left=this._right="";else{if(e!==MdPanelPosition.absPosition.BOTTOM&&e!==MdPanelPosition.absPosition.TOP){var n=Object.keys(MdPanelPosition.absPosition).join().toLowerCase();throw new Error("mdPanel: Position must be one of "+n+".")}this._top=this._bottom=""}return this["_"+e]=angular.isString(t)?t:"0",this},MdPanelPosition.prototype.top=function(e){return this._setPosition(MdPanelPosition.absPosition.TOP,e)},MdPanelPosition.prototype.bottom=function(e){return this._setPosition(MdPanelPosition.absPosition.BOTTOM,e)},MdPanelPosition.prototype.start=function(e){var t=this._isRTL?MdPanelPosition.absPosition.RIGHT:MdPanelPosition.absPosition.LEFT;return this._setPosition(t,e)},MdPanelPosition.prototype.end=function(e){var t=this._isRTL?MdPanelPosition.absPosition.LEFT:MdPanelPosition.absPosition.RIGHT;return this._setPosition(t,e)},MdPanelPosition.prototype.left=function(e){return this._setPosition(MdPanelPosition.absPosition.LEFT,e)},MdPanelPosition.prototype.right=function(e){return this._setPosition(MdPanelPosition.absPosition.RIGHT,e)},MdPanelPosition.prototype.centerHorizontally=function(){return this._left="50%",this._right="",this._translateX=["-50%"],this},MdPanelPosition.prototype.centerVertically=function(){return this._top="50%",this._bottom="",this._translateY=["-50%"],this},MdPanelPosition.prototype.center=function(){return this.centerHorizontally().centerVertically()},MdPanelPosition.prototype.relativeTo=function(e){return this._absolute=!1,this._relativeToEl=getElement(e),this},MdPanelPosition.prototype.addPanelPosition=function(e,t){if(!this._relativeToEl)throw new Error("mdPanel: addPanelPosition can only be used with relative positioning. Set relativeTo first.");return validatePosition(MdPanelPosition.xPosition,e),validatePosition(MdPanelPosition.yPosition,t),this._positions.push({x:e,y:t}),this},MdPanelPosition.prototype.withOffsetX=function(e){return this._translateX.push(addUnits(e)),this},MdPanelPosition.prototype.withOffsetY=function(e){return this._translateY.push(addUnits(e)),this},MdPanelPosition.prototype.getTop=function(){return this._top},MdPanelPosition.prototype.getBottom=function(){return this._bottom},MdPanelPosition.prototype.getLeft=function(){return this._left},MdPanelPosition.prototype.getRight=function(){return this._right},MdPanelPosition.prototype.getTransform=function(){return(this._reduceTranslateValues("translateX",this._translateX)+" "+this._reduceTranslateValues("translateY",this._translateY)).trim()},MdPanelPosition.prototype._setTransform=function(e){return e.css(this._$mdConstant.CSS.TRANSFORM,this.getTransform())},MdPanelPosition.prototype._isOnscreen=function(e){var t=parseInt(this.getLeft()),n=parseInt(this.getTop());if(this._translateX.length||this._translateY.length){var i=getComputedTranslations(e,this._$mdConstant.CSS.TRANSFORM);t+=i.x,n+=i.y}var o=t+e[0].offsetWidth,a=n+e[0].offsetHeight;return 0<=t&&0<=n&&a<=this._$window.innerHeight&&o<=this._$window.innerWidth},MdPanelPosition.prototype.getActualPosition=function(){return this._actualPosition},MdPanelPosition.prototype._reduceTranslateValues=function(n,e){return e.map(function(e){var t=angular.isFunction(e)?addUnits(e(this)):e;return n+"("+t+")"},this).join(" ")},MdPanelPosition.prototype._setPanelPosition=function(e){if(e.removeClass("_md-panel-position-adjusted"),this._absolute)this._setTransform(e);else{if(this._actualPosition)return this._calculatePanelPosition(e,this._actualPosition),this._setTransform(e),void this._constrainToViewport(e);for(var t=0;t<this._positions.length;t++)if(this._actualPosition=this._positions[t],this._calculatePanelPosition(e,this._actualPosition),this._setTransform(e),this._isOnscreen(e))return;this._constrainToViewport(e)}},MdPanelPosition.prototype._constrainToViewport=function(e){var t=MdPanelPosition.viewportMargin,n=this._top,i=this._left;if(this.getTop()){var o=parseInt(this.getTop()),a=e[0].offsetHeight+o,s=this._$window.innerHeight;o<t?this._top=t+"px":s<a&&(this._top=o-(a-s+t)+"px")}if(this.getLeft()){var r=parseInt(this.getLeft()),l=e[0].offsetWidth+r,p=this._$window.innerWidth;r<t?this._left=t+"px":p<l&&(this._left=r-(l-p+t)+"px")}e.toggleClass("_md-panel-position-adjusted",this._top!==n||this._left!==i)},MdPanelPosition.prototype._reverseXPosition=function(e){if(e===MdPanelPosition.xPosition.CENTER)return e;var t="start";return-1<e.indexOf(t)?e.replace(t,"end"):e.replace("end",t)},MdPanelPosition.prototype._bidi=function(e){return this._isRTL?this._reverseXPosition(e):e},MdPanelPosition.prototype._calculatePanelPosition=function(e,t){var n=e[0].getBoundingClientRect(),i=Math.max(n.width,e[0].clientWidth),o=Math.max(n.height,e[0].clientHeight),a=this._relativeToEl[0].getBoundingClientRect(),s=a.left,r=a.right,l=a.width;switch(this._bidi(t.x)){case MdPanelPosition.xPosition.OFFSET_START:this._left=s-i+"px";break;case MdPanelPosition.xPosition.ALIGN_END:this._left=r-i+"px";break;case MdPanelPosition.xPosition.CENTER:var p=s+.5*l-.5*i;this._left=p+"px";break;case MdPanelPosition.xPosition.ALIGN_START:this._left=s+"px";break;case MdPanelPosition.xPosition.OFFSET_END:this._left=r+"px"}var c=a.top,h=a.bottom,d=a.height;switch(t.y){case MdPanelPosition.yPosition.ABOVE:this._top=c-o+"px";break;case MdPanelPosition.yPosition.ALIGN_BOTTOMS:this._top=h-o+"px";break;case MdPanelPosition.yPosition.CENTER:var u=c+.5*d-.5*o;this._top=u+"px";break;case MdPanelPosition.yPosition.ALIGN_TOPS:this._top=c+"px";break;case MdPanelPosition.yPosition.BELOW:this._top=h+"px"}},MdPanelAnimation.animation={SLIDE:"md-panel-animate-slide",SCALE:"md-panel-animate-scale",FADE:"md-panel-animate-fade"},MdPanelAnimation.prototype.openFrom=function(e){return e=e.target?e.target:e,this._openFrom=this._getPanelAnimationTarget(e),this._closeTo||(this._closeTo=this._openFrom),this},MdPanelAnimation.prototype.closeTo=function(e){return this._closeTo=this._getPanelAnimationTarget(e),this},MdPanelAnimation.prototype.duration=function(e){return e&&(angular.isNumber(e)?this._openDuration=this._closeDuration=t(e):angular.isObject(e)&&(this._openDuration=t(e.open),this._closeDuration=t(e.close))),this._rawDuration=e,this;function t(e){if(angular.isNumber(e))return e/1e3}},MdPanelAnimation.prototype._getPanelAnimationTarget=function(e){return angular.isDefined(e.top)||angular.isDefined(e.left)?{element:void 0,bounds:{top:e.top||0,left:e.left||0}}:this._getBoundingClientRect(getElement(e))},MdPanelAnimation.prototype.withAnimation=function(e){return this._animationClass=e,this},MdPanelAnimation.prototype.animateOpen=function(e){var t=this._$mdUtil.dom.animator;this._fixBounds(e);var n={},i=e[0].style.transform||"",o=t.toTransformCss(i),a=t.toTransformCss(i);switch(this._animationClass){case MdPanelAnimation.animation.SLIDE:e.css("opacity","1"),n={transitionInClass:"_md-panel-animate-enter",transitionOutClass:"_md-panel-animate-leave"};var s=t.calculateSlideToOrigin(e,this._openFrom)||"";o=t.toTransformCss(s+" "+i);break;case MdPanelAnimation.animation.SCALE:n={transitionInClass:"_md-panel-animate-enter"};var r=t.calculateZoomToOrigin(e,this._openFrom)||"";o=t.toTransformCss(i+" "+r);break;case MdPanelAnimation.animation.FADE:n={transitionInClass:"_md-panel-animate-enter"};break;default:n=angular.isString(this._animationClass)?{transitionInClass:this._animationClass}:{transitionInClass:this._animationClass.open,transitionOutClass:this._animationClass.close}}return n.duration=this._openDuration,t.translate3d(e,o,a,n)},MdPanelAnimation.prototype.animateClose=function(e){var t=this._$mdUtil.dom.animator,n={},i=e[0].style.transform||"",o=t.toTransformCss(i),a=t.toTransformCss(i);switch(this._animationClass){case MdPanelAnimation.animation.SLIDE:e.css("opacity","1"),n={transitionInClass:"_md-panel-animate-leave",transitionOutClass:"_md-panel-animate-enter _md-panel-animate-leave"};var s=t.calculateSlideToOrigin(e,this._closeTo)||"";a=t.toTransformCss(s+" "+i);break;case MdPanelAnimation.animation.SCALE:n={transitionInClass:"_md-panel-animate-scale-out _md-panel-animate-leave",transitionOutClass:"_md-panel-animate-scale-out _md-panel-animate-enter _md-panel-animate-leave"};var r=t.calculateZoomToOrigin(e,this._closeTo)||"";a=t.toTransformCss(i+" "+r);break;case MdPanelAnimation.animation.FADE:n={transitionInClass:"_md-panel-animate-fade-out _md-panel-animate-leave",transitionOutClass:"_md-panel-animate-fade-out _md-panel-animate-enter _md-panel-animate-leave"};break;default:n=angular.isString(this._animationClass)?{transitionOutClass:this._animationClass}:{transitionInClass:this._animationClass.close,transitionOutClass:this._animationClass.open}}return n.duration=this._closeDuration,t.translate3d(e,o,a,n)},MdPanelAnimation.prototype._fixBounds=function(e){var t=e[0].offsetWidth,n=e[0].offsetHeight;this._openFrom&&null==this._openFrom.bounds.height&&(this._openFrom.bounds.height=n),this._openFrom&&null==this._openFrom.bounds.width&&(this._openFrom.bounds.width=t),this._closeTo&&null==this._closeTo.bounds.height&&(this._closeTo.bounds.height=n),this._closeTo&&null==this._closeTo.bounds.width&&(this._closeTo.bounds.width=t)},MdPanelAnimation.prototype._getBoundingClientRect=function(e){if(e instanceof angular.element)return{element:e,bounds:e[0].getBoundingClientRect()}},ngmaterial.components.panel=angular.module("material.components.panel");